//*****************************************************************************
//*
//*
//*		IconSelDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "Picture.h"
#include "IconSelDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CIconSelDlg, CDialog)
	//{{AFX_MSG_MAP(CIconSelDlg)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		Dialogfeld CIconSelDlg 
//*
//*****************************************************************************
CIconSelDlg::CIconSelDlg(CWnd *pParent)
	: CDialog(CIconSelDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CIconSelDlg)
	m_iIconType = 0;
	m_sIconNr = _T("0");
	m_sIconW = _T("32");
	m_sIconC = _T("32");
	m_sIconH = _T("16");
	//}}AFX_DATA_INIT

	m_iIconNumber = 0;
	m_iIconWidth  = 32;
	m_iIconHeight = 32;
	m_iIconColor  = 16;

	m_bIsIcon	  = FALSE;	
}




//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CIconSelDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIconSelDlg)
	DDX_CBIndex(pDX, IDC_COMBO1, m_iIconType);
	DDX_Text(pDX, IDC_EDIT1, m_sIconNr);
	DDX_Text(pDX, IDC_EDIT2, m_sIconW);
	DDX_Text(pDX, IDC_EDIT3, m_sIconH);
	DDX_Text(pDX, IDC_EDIT4, m_sIconC);
	//}}AFX_DATA_MAP

	EnableDlgItem(IDC_EDIT2,m_iIconType==19);
	EnableDlgItem(IDC_EDIT3,m_iIconType==19);
	EnableDlgItem(IDC_EDIT4,m_iIconType==19);

}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
// Behandlungsroutinen fr Nachrichten CIconSelDlg 
BOOL CIconSelDlg::OnInitDialog() 
{

	if(m_bIsIcon)m_iIconNumber=0;

	m_sIconNr.Format("%i",m_iIconNumber);
	m_sIconW .Format("%i",m_iIconWidth );
	m_sIconH .Format("%i",m_iIconHeight);
	m_sIconC .Format("%i",m_iIconColor );
	
	EnableDlgItem(IDC_EDIT1,!m_bIsIcon);
	
	CDialog::OnInitDialog();
	
	return TRUE;
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CIconSelDlg::OnCancel() 
{
	OnOK();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CIconSelDlg::OnOK() 
{
int i;

	UpdateData();
	
	m_iIconNumber = strtoi(m_sIconNr);
	m_iIconWidth  = strtoi(m_sIconW);
	m_iIconHeight = strtoi(m_sIconH);
	m_iIconColor  = strtoi(m_sIconC);
	
	i=(m_iIconColor)? m_iIconColor:0xFF;
	if(m_bIsIcon)m_iIconNumber=0;
	
	switch(m_iIconType)
		{
	default:
	case 0:	m_iIconBitmap=-1;				break;
	case 1:	m_iIconBitmap=0x80FF1010;		break;
	case 2:	m_iIconBitmap=0x80011010;		break;
	case 3:	m_iIconBitmap=0x80041010;		break;
	case 4:	m_iIconBitmap=0x80081010;		break;
	case 5:	m_iIconBitmap=0x80181010;		break;
	case 6:	m_iIconBitmap=0x80201010;		break;
	case 7:	m_iIconBitmap=0x80FF2020;		break;
	case 8:	m_iIconBitmap=0x80012020;		break;
	case 9:	m_iIconBitmap=0x80042020;		break;
	case 10:m_iIconBitmap=0x80082020;		break;
	case 11:m_iIconBitmap=0x80182020;		break;
	case 12:m_iIconBitmap=0x80202020;		break;
	case 13:m_iIconBitmap=0x80FF3030;		break;
	case 14:m_iIconBitmap=0x80013030;		break;
	case 15:m_iIconBitmap=0x80023030;		break;
	case 16:m_iIconBitmap=0x80083030;		break;
	case 17:m_iIconBitmap=0x80183030;		break;
	case 18:m_iIconBitmap=0x80203030;		break;
	case 19:m_iIconBitmap=0x80000000;
			m_iIconBitmap|= m_iIconWidth &0xFF;
			m_iIconBitmap|=(m_iIconHeight&0xFF)<<8;
			m_iIconBitmap|=(i            &0xFF)<<16;
		}
	
	CDialog::OnOK();
}




//*****************************************************************************
//*
//*		OnSelchange
//*
//*****************************************************************************
void CIconSelDlg::OnSelchange() 
{
	UpdateData();		
}
