//*****************************************************************************
//*
//*
//*		PictureDoc.cpp : Implementierung der Klasse CPictureDoc
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "Picture.h"
#include "PictureDoc.h"
#include "IconSelDlg.h"
#include "Image\ImageSaver.h"
#include "Image\ImageLoader.h"
#include "Image\IconDecoder.h"
#include "Image\IconEncoder.h"



#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CPictureDoc, CDocument)

BEGIN_MESSAGE_MAP(CPictureDoc, CDocument)
	//{{AFX_MSG_MAP(CPictureDoc)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_EDIT_COPY,OnCopy)
	ON_COMMAND(ID_EDIT_PASTE,OnPaste)
	ON_COMMAND(ID_FILE_OPEN,OnFileOpen)
END_MESSAGE_MAP()



//*****************************************************************************
//*
//*		CPictureDlg
//*
//*****************************************************************************
//	Das ist der Dialog mit der Vorschau
class CPictureDlg : public CFileDialog
{
public:

	 CPictureDlg( BOOL bOpenFileDialog, LPCTSTR lpszDefExt = "bmp", LPCTSTR lpszFileName = NULL, DWORD dwFlags = OFN_EXPLORER|OFN_ENABLESIZING|OFN_HIDEREADONLY, LPCTSTR lpszFilter = "Bilder|*.jpg;*.jpeg;*.gif;*.bmp;*.png;*.tif;*.tiff;*.xpm;*.ico;*.exe;*.ocx;*.dll;*.xwd;*.pnm;*.eps;*.ps;*.prn|Alle Dateien|*.*|", CWnd* pParentWnd = NULL );
	~CPictureDlg();


protected:

	virtual void OnFileNameChange( );

	HBITMAP		bitmap;

};


//*****************************************************************************
//*
//*		DialogFeld CPictureDlg
//*
//*****************************************************************************
CPictureDlg::CPictureDlg( BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName, DWORD dwFlags , LPCTSTR lpszFilter, CWnd* pParentWnd)
: CFileDialog(bOpenFileDialog,lpszDefExt,lpszFileName,dwFlags,lpszFilter,pParentWnd)
{

	// Einhngen der Dialog-Resource fr die Vorschau
	m_ofn.lpTemplateName = MAKEINTRESOURCE(IDD_PICTUREDLG);
	m_ofn.Flags         |= OFN_ENABLEHOOK|OFN_ENABLETEMPLATE;
	bitmap = 0;
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CPictureDlg::~CPictureDlg()
{
	if(bitmap)DeleteObject(bitmap);
}

//*****************************************************************************
//*
//*		OnFileNameChange
//*
//*****************************************************************************
//	Diese Funktion wird aufgerufen wenn eine andere Datei aufgerufen wird.
void CPictureDlg::OnFileNameChange( )
{
char		file[MAX_PATH];
BitmapImage image,img_small;
CStatic    *img_wnd;
CStatic	   *frm_wnd;
CWnd	   *wnd;
CRect		rect;


	file[0]=0;
	wnd=GetParent();
	img_wnd=(CStatic*)GetDlgItem(IDC_IMAGE);
	CommDlg_OpenSave_GetFilePath(wnd->m_hWnd,file,sizeof(file));

	if(ExistFile(file)!=1)			// Prfen ob die Datei existiert
		{
		img_wnd->SetBitmap(0);
		if(bitmap)
			{
			DeleteObject(bitmap);
			bitmap=0;
			}
		return;
		}

	SetCursor(IDC_WAIT);

	if(ImageLoader(file,&image))	// Das Bild laden
		{
		img_wnd->SetBitmap(0);
		if(bitmap)
			{
			DeleteObject(bitmap);
			bitmap=0;
			}
		SetCursor(IDC_ARROW);
		return;
		}

									// Das Bild in die Vorschau geben
	frm_wnd=(CStatic*)GetDlgItem(IDC_FRAME);
	frm_wnd->GetClientRect(&rect);
	img_small.Stretch(image,rect.Width(),rect.Height(),1);
	bitmap=img_small.CreateBitmap(img_wnd->m_hWnd);
	img_wnd->SetBitmap(bitmap);
	SetCursor(IDC_ARROW);

}


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CPictureDoc::CPictureDoc()
{
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CPictureDoc::~CPictureDoc()
{
}


//*****************************************************************************
//*
//*		OnNewDocument
//*
//*****************************************************************************
BOOL CPictureDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;


	image.Clear();
	SetModifiedFlag(FALSE);

	return TRUE;
}



//*****************************************************************************
//*
//*		Serialize
//*
//*****************************************************************************
void CPictureDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}


//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CPictureDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPictureDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif


//*****************************************************************************
//*
//*		OnOpenDocument
//*
//*****************************************************************************
BOOL CPictureDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
static	CIconSelDlg	idlg;

	SetCursor(IDC_WAIT);

	if(CmpFileType(lpszPathName,"ico;exe;dll;ocx;axx;sys"))
		{
		IconDecoder	idecoder;
		CString		text;

		idlg.m_bIsIcon=CmpFileType(lpszPathName,"ico");
		idlg.DoModal();
		try	{
			idecoder.ReadImage(lpszPathName,&image,0,idlg.m_iIconBitmap,idlg.m_iIconNumber);
			}
		catch(EGraphicsException &ee)
			{
			text.Format("Fehler beim Laden:\n%s",ee.what());
			MessageBox(0,text,"Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}

		catch(...)
			{
			MessageBox(0,"Unbekannter Fehler","Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}

		UpdateAllViews(0);
		SetCursor(IDC_ARROW);

		return TRUE;
		}

	if(ImageLoader(lpszPathName,&image))
		{
		CString	text;
		text.Format("Fehler beim Laden:\n%s",ImageLoaderError());
		MessageBox(0,text,"Fehler",MB_OK|MB_ICONERROR);
		UpdateAllViews(0);
		SetCursor(IDC_ARROW);
		return FALSE;
		}

	UpdateAllViews(0);
	SetCursor(IDC_ARROW);

return TRUE;
}


//*****************************************************************************
//*
//*		OnSaveDocument
//*
//*****************************************************************************
BOOL CPictureDoc::OnSaveDocument(LPCTSTR lpszPathName)
{

	SetCursor(IDC_WAIT);

	if(CmpFileType(lpszPathName,"ico"))
		{
		IconEncoder	iencoder;
		CString		text;

		try	{
			iencoder.WriteImage(lpszPathName,&image,8);
			}
		catch(EGraphicsException &ee)
			{
			text.Format("Fehler beim Speichern:\n%s",ee.what());
			MessageBox(0,text,"Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}

		catch(...)
			{
			MessageBox(0,"Unbekannter Fehler","Fehler",MB_OK|MB_ICONERROR);
			return FALSE;
			}

		UpdateAllViews(0);
		SetCursor(IDC_ARROW);

		return TRUE;
		}

	if(ImageSaver(lpszPathName,&image))
		{
		CString	text;
		text.Format("Fehler beim Speichern:\n%s",ImageLoaderError());
		MessageBox(0,text,"Fehler",MB_OK|MB_ICONERROR);
		SetCursor(IDC_ARROW);
		return FALSE;
		}

	SetModifiedFlag(FALSE);
	SetCursor(IDC_ARROW);

return TRUE;
}


//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
//	Kopiert das Bild in die Zwischenablage
void CPictureDoc::OnCopy()
{
	image.Copy();
}


//*****************************************************************************
//*
//*		OnPaste
//*
//*****************************************************************************
//	Kopiert das Bild in die Zwischenablage
void CPictureDoc::OnPaste()
{
if(image.Paste())
	{
	UpdateAllViews(0);
	}
else{
	MessageBeep(MB_ICONEXCLAMATION);
	SetModifiedFlag(TRUE);
	}
}




//*****************************************************************************
//*
//*		OnFileOpen
//*
//*****************************************************************************
void CPictureDoc::OnFileOpen()
{
CPictureDlg		dlg(TRUE);


	if(dlg.DoModal()!=IDOK)return;

	OnOpenDocument(dlg.GetFileName());

}
