//*****************************************************************************
//*
//*
//*		PictureView.cpp : Implementierung der Klasse CPictureView
//*
//*
//*****************************************************************************
//
//	Copyright  2007	Anton Zechner
//

#include "StdAfx.h"
#include "Picture.h"

#include "PictureDoc.h"
#include "PictureView.h"

#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CPictureView, CView)

BEGIN_MESSAGE_MAP(CPictureView, CView)
	//{{AFX_MSG_MAP(CPictureView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CPictureView::CPictureView()
{
}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CPictureView::~CPictureView()
{
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CPictureView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}


//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
// CPictureView Zeichnen

void CPictureView::OnDraw(CDC *pDC)
{
CRect	rect;

	CPictureDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	GetClientRect(&rect);

	pDoc->image.SetDIB(pDC->m_hDC,0,0);		// Das Bitmap anzeigen

	pDC->SelectStockObject(NULL_PEN);
	pDC->SelectStockObject(WHITE_BRUSH);

	rect.left=pDoc->image.Width();
	pDC->Rectangle(&rect);					// Rechts einen weisen Rand zeichnen

	rect.left=0;
	rect.top=pDoc->image.Height();
	pDC->Rectangle(&rect);					// Unten einen weisen Rand zeichnen




}


//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CPictureView::AssertValid() const
{
	CView::AssertValid();
}

void CPictureView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPictureDoc* CPictureView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPictureDoc)));
	return (CPictureDoc*)m_pDocument;
}
#endif //_DEBUG

